Lettcode_292_Nim Game
Posted 皮斯特劳沃
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了Lettcode_292_Nim Game相关的知识,希望对你有一定的参考价值。
You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.
Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.
For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.
思路:
(1)题意为给定一堆石头,你和朋友每次可以从中选取1、2、3块石头,谁拿到最后一块石头谁就取胜。请问在你先拿的情况下每次是否能够取胜。这道题属于非常简单的题,这里仅作为存档。
(2)每次可以拿1、2、3块石头,当数量为4时,发现赢不了;同理,当数量为8、12、16…..4n (n>1)时,同样赢不了。可发现当数量为4的倍数时,永远也赢不了。
(3)希望本文对你有所帮助。
算法代码实现如下:
package leetcode;
public class Nim_Game {
public boolean canWinNim(int n) {
if (n > 0 && n % 4 == 0) {
return false;
} else {
return true;
}
}
}
以上是关于Lettcode_292_Nim Game的主要内容,如果未能解决你的问题,请参考以下文章